## pve-lxc-syscalld 1.3.0

=== Makefile ===
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

include defines.mk

GITVERSION:=$(shell git rev-parse HEAD)

SUBDIRS := etc

ifeq ($(BUILD_MODE), release)
CARGO_BUILD_ARGS += --release
COMPILEDIR := target/release
else
COMPILEDIR := target/debug
endif

SERVICE_BIN := pve-lxc-syscalld

COMPILED_BINS := \
	$(addprefix $(COMPILEDIR)/,$(SERVICE_BIN))

DEB=$(PACKAGE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).deb
DSC=$(PACKAGE)_$(DEB_VERSION).dsc

BUILDDIR ?= $(PACKAGE)-$(DEB_VERSION_UPSTREAM)

all: cargo-build $(SUBDIRS)

.PHONY: $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@

.PHONY: cargo-build
cargo-build:
	cargo build $(CARGO_BUILD_ARGS)

.PHONY: test
test:
	cargo test $(CARGO_BUILD_ARGS)

.PHONY: check
check: test

$(COMPILED_BINS): cargo-build

install: $(COMPILED_BINS)
	install -dm755 $(DESTDIR)$(LIBEXECDIR)/pve-lxc-syscalld
	$(foreach i,$(SERVICE_BIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(LIBEXECDIR)/pve-lxc-syscalld/ ;)

$(BUILDDIR): src debian etc Cargo.toml
	rm -rf $(BUILDDIR) $(BUILDDIR).tmp
	mkdir $(BUILDDIR).tmp
	#mkdir $(BUILDDIR).tmp/.cargo
	cp -a -t $(BUILDDIR).tmp $^ Makefile defines.mk
	#cp -a -t $(BUILDDIR).tmp/.cargo .cargo/config
	echo "git clone git://git.proxmox.com/git/pve-lxc-syscalld.git\\ngit checkout $(shell git rev-parse HEAD)" > $(BUILDDIR).tmp/debian/SOURCE
	mv $(BUILDDIR).tmp $(BUILDDIR)

.PHONY: deb
deb: $(DEB)
$(DEB): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -b -us -uc
	lintian $(DEB)

.PHONY: dsc
dsc: $(DSC)
$(DSC): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -S -us -uc -d
	lintian $(DSC)

sbuild: $(DSC)
	sbuild $(DSC)

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(DEB)
	dcmd --deb pve-lxc-syscalld_*.changes \
	    | grep -v '.changes$$' \
	    | tar -cf- -T- \
	    | ssh -X repoman@repo.proxmox.com upload --product pve --dist $(UPLOAD_DIST)

.PHONY: dinstall
dinstall:
	$(MAKE) deb
	sudo -k dpkg -i $(DEB)

clean:
	$(foreach i,$(SUBDIRS), \
	    $(MAKE) -C $(i) clean ;)
	rm -rf ./target
	rm -rf ./$(BUILDDIR)
	rm -f -- *.deb *.dsc *.tar.?z *.buildinfo *.build *.changes

=== etc/Makefile ===
include ../defines.mk

UNITS := pve-lxc-syscalld.service

all: $(UNITS)

clean:
	rm -f $(UNITS)

.SUFFIXES: .service.in .service
.service.in.service:
	sed \
	    -e 's!%LIBEXECDIR%!$(LIBEXECDIR)!g' \
	    $< >$@.tmp
	mv $@.tmp $@

=== debian/changelog ===
pve-lxc-syscalld (1.3.0) bookworm; urgency=medium

  * rebuild for Debian 12 bookworm based release series

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 May 2023 13:33:14 +0200

rust-pve-lxc-syscalld (1.2.2-1) pve; urgency=medium

  * remove old poll/event handling for SEQPACKET socket

  * re-enable non-blocking client sockets

 -- Proxmox Support Team <support@proxmox.com>  Mon, 18 Jul 2022 12:15:06 +0200

rust-pve-lxc-syscalld (1.2.1-1) pve; urgency=medium

  * revert non-blocking socket i/o patch

 -- Proxmox Support Team <support@proxmox.com>  Mon, 18 Jul 2022 11:17:54 +0200

rust-pve-lxc-syscalld (1.2.0-1) pve; urgency=medium

  * update to rust edition 2021

  * update nix dependency to 0.24

  * keep worker count between 2 and 4 to avoid lots of idle threads on high
    thread cpus, as we rarely get involved in container activity

  * use non-blocking i/o for sockets

 -- Proxmox Support Team <support@proxmox.com>  Thu, 07 Jul 2022 15:18:20 +0200

rust-pve-lxc-syscalld (1.1.1-1) pve; urgency=medium

  * improve handling of AT_FDCWD as file descriptor parameter

 -- Proxmox Support Team <support@proxmox.com>  Wed, 01 Jun 2022 09:42:15 +0200

rust-pve-lxc-syscalld (1.1.0-1) pve; urgency=medium

  * accept negative file descriptors, as they have valid use cases

 -- Proxmox Support Team <support@proxmox.com>  Fri, 07 Jan 2022 14:20:14 +0100

rust-pve-lxc-syscalld (1.0.0-1) pve; urgency=medium

  * support pure cgroupv2 environments

  * fix issue with tokio 1.0 update causing pipes in forked syscalls to
    wrongly indicate EOF

 -- Proxmox Support Team <support@proxmox.com>  Thu, 10 Jun 2021 12:03:52 +0200

rust-pve-lxc-syscalld (0.9.2-1) pve; urgency=medium

  * update to tokio 1.0

  * re-build for Proxmox VE 7 / Debian Bullseye

 -- Proxmox Support Team <support@proxmox.com>  Wed, 12 May 2021 21:05:15 +0200

rust-pve-lxc-syscalld (0.9.1-1) pve; urgency=medium

  * fix handling of '--' parameter separator and error output

 -- Proxmox Support Team <support@proxmox.com>  Thu, 30 Jan 2020 09:02:35 +0100

rust-pve-lxc-syscalld (0.9.0-1) pve; urgency=medium

  * initial development release

 -- Proxmox Support Team <support@proxmox.com>  Wed, 29 Jan 2020 12:00:00 +0100

=== debian/control ===
Source: pve-lxc-syscalld
Section: admin
Priority: optional
Build-Depends: debhelper-compat (= 13),
 bash-completion,
 libsystemd-dev,
 dh-cargo (>= 25),
 cargo:native,
 rustc:native,
 libstd-rust-dev,
 librust-anyhow-1+default-dev,
 librust-bitflags-1+default-dev (>= 1.2-~~),
 librust-lazy-static-1+default-dev (>= 1.4-~~),
 librust-libc-0.2+default-dev,
 librust-nix-0.26+default-dev,
 librust-num-cpus-1+default-dev,
 librust-tokio-1+default-dev,
 librust-tokio-1+io-util-dev,
 librust-tokio-1+net-dev,
 librust-tokio-1+rt-multi-thread-dev,
Maintainer: Proxmox Support Team <support@proxmox.com>
Standards-Version: 4.6.1
Vcs-Git: git://git.proxmox.com/git/pve-lxc-syscalld.git
Vcs-Browser: https://git.proxmox.com/?p=pve-lxc-syscalld.git;a=summary
Homepage: https://www.proxmox.com
Rules-Requires-Root: no

Package: pve-lxc-syscalld
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: PVE LXC syscall daemon
 A daemon which handles a selected subset of syscalls for unprivileged
 containers.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/rustc/architecture.mk

export BUILD_MODE=release

CARGO=/usr/share/cargo/bin/cargo

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_HOME = $(CURDIR)/debian/cargo_home

export DEB_CARGO_CRATE=pve-lxc-syscalld_$(DEB_VERSION_UPSTREAM)
export DEB_CARGO_PACKAGE=pve-lxc-syscalld

%:
	dh $@

override_dh_auto_configure:
	@perl -ne 'if (/^version\s*=\s*"(\d+(?:\.\d+)+)"/) { my $$v_cargo = $$1; my $$v_deb = "$(DEB_VERSION_UPSTREAM)"; \
	    die "ERROR: d/changelog <-> Cargo.toml version mismatch: $$v_cargo != $$v_deb\n" if $$v_cargo ne $$v_deb; exit(0); }' Cargo.toml
	$(CARGO) prepare-debian $(CURDIR)/debian/cargo_registry --link-from-system
	dh_auto_configure

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_build:
	dh_auto_build -- \
	    LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	dh_auto_install -- \
	    LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

#override_dh_installinit:
#	dh_installinit
#	dh_installinit --name pve-lxc-syscalld

# # workaround https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=933541
# # TODO: remove once available (Debian 11 ?)
# override_dh_dwz:
#	dh_dwz --no-dwz-multifile
